---
title: Update a Datasource
description: Update a datasource using it numeric ID
url: https://storyblok.com/docs/api/management/datasources/update-a-datasource
---

# Update a Datasource

PUT

```html
https://mapi.storyblok.com/v1/spaces/:space_id/datasources/:datasource_id
```

Update a datasource using it numeric ID.

## Path parameters

-   `:space_id` (required) (number)
    
    Numeric ID of a space
    
-   `:datasource_id` (required) (number)
    
    Numeric id of a datasource
    

## Request body properties

-   `datasource` (string)
    
    A [datasource object](/docs/api/management/datasources/the-datasource-object)
    

## Examples

-   cURL
    
    ```shellscript
    curl "https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91" \
      -X PUT \
      -H "Authorization: YOUR_OAUTH_TOKEN" \
      -H "Content-Type: application/json" \
      -d "{\"datasource\":{\"name\":\"Labels for Website\",\"slug\":\"labels_for_website\"}}"
    ```
    
-   JS
    
    ```javascript
    // storyblok-js-client@>=7, node@>=18
    import Storyblok from "storyblok-js-client";
    
    const storyblok = new Storyblok({
      oauthToken: "YOUR_PERSONAL_ACCESS_TOKEN",
    });
    
    try {
      const response = await storyblok.put('spaces/288868932106293/datasources/91', {
        "datasource": {
          "name": "Labels for Website",
          "slug": "labels_for_website"
        }
      })
      console.log({ response })
    } catch (error) {
      console.log(error)
    }
    ```
    
-   PHP
    
    ```php
    $client = new \Storyblok\ManagementClient('YOUR_OAUTH_TOKEN');
    
    $payload = ["datasource" => ["name" => "Labels for Website","slug" => "labels_for_website"]];
    
    $client->put('spaces/288868932106293/datasources/91', $payload)->getBody();
    ```
    
-   Java
    
    ```java
    HttpResponse<String> response = Unirest.put("https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91")
      .header("Content-Type", "application/json")
      .header("Authorization", "YOUR_OAUTH_TOKEN")
      .body({"datasource":{"name":"Labels for Website","slug":"labels_for_website"}})
      .asString();
    ```
    
-   C#
    
    ```csharp
    var client = new RestClient("https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91");
    var request = new RestRequest(Method.PUT);
    
    request.AddHeader("Content-Type", "application/json");
    request.AddHeader("Authorization", "YOUR_OAUTH_TOKEN");
    request.AddParameter("application/json", "{\"datasource\":{\"name\":\"Labels for Website\",\"slug\":\"labels_for_website\"}}", ParameterType.RequestBody);
    IRestResponse response = client.Execute(request);
    ```
    
-   Python
    
    ```python
    import requests
    
    url = "https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91"
    
    querystring = {}
    
    payload = {"datasource":{"name":"Labels for Website","slug":"labels_for_website"}}
    headers = {
      'Content-Type': "application/json",
      'Authorization': "YOUR_OAUTH_TOKEN"
    }
    
    response = requests.request("PUT", url, data=payload, headers=headers, params=querystring)
    
    print(response.text)
    ```
    
-   Ruby
    
    ```ruby
    require 'storyblok'
    client = Storyblok::Client.new(oauth_token: 'YOUR_OAUTH_TOKEN')
    
    payload = {"datasource" => {"name" => "Labels for Website","slug" => "labels_for_website"}}
    
    client.put('spaces/288868932106293/datasources/91', payload)
    ```
    
-   Swift
    
    ```swift
    let storyblok = URLSession(storyblok: .mapi(accessToken: .oauth("YOUR_OAUTH_TOKEN")))
    var request = URLRequest(storyblok: storyblok, path: "spaces/288868932106293/datasources/91")
    request.httpMethod = "PUT"
    request.httpBody = try JSONSerialization.data(withJSONObject: [
        "datasource": [
            "name": "Labels for Website",
            "slug": "labels_for_website",
        ],
    ])
    let (data, _) = try await storyblok.data(for: request)
    print(try JSONSerialization.jsonObject(with: data))
    ```
    
-   Kotlin
    
    ```kotlin
    val client = HttpClient {
        install(Storyblok(MAPI)) {
            accessToken = OAuth("YOUR_OAUTH_TOKEN")
        }
    }
    
    val response = client.put("spaces/288868932106293/datasources/91") {
        setBody(buildJsonObject {
            putJsonObject("datasource") {
                put("name", "Labels for Website")
                put("slug", "labels_for_website")
            }
        })
    }
    
    println(response.body<JsonElement>())
    ```

Request for updating values in a specific dimension.

> [!TIP]
> To update `dimensions`, use the `dimensions_attributes` key.

-   cURL
    
    ```shellscript
    curl "https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91" \
      -X PUT \
      -H "Authorization: YOUR_OAUTH_TOKEN" \
      -H "Content-Type: application/json" \
      -d "{\"datasource\":{\"dimensions_attributes\":[{\"entry_value\":\"another_slug\",\"name\":\"Another Name\"}],\"name\":\"Labels for Website\",\"slug\":\"label\"}}"
    ```
    
-   JS
    
    ```javascript
    // storyblok-js-client@>=7, node@>=18
    import Storyblok from "storyblok-js-client";
    
    const storyblok = new Storyblok({
      oauthToken: "YOUR_PERSONAL_ACCESS_TOKEN",
    });
    
    try {
      const response = await storyblok.put('spaces/288868932106293/datasources/91', {
        "datasource": {
          "dimensions_attributes": [
            {
              "entry_value": "another_slug",
              "name": "Another Name"
            }
          ],
          "name": "Labels for Website",
          "slug": "label"
        }
      })
      console.log({ response })
    } catch (error) {
      console.log(error)
    }
    ```
    
-   PHP
    
    ```php
    $client = new \Storyblok\ManagementClient('YOUR_OAUTH_TOKEN');
    
    $payload = ["datasource" => ["dimensions_attributes" => [["entry_value" => "another_slug","name" => "Another Name"]],"name" => "Labels for Website","slug" => "label"]];
    
    $client->put('spaces/288868932106293/datasources/91', $payload)->getBody();
    ```
    
-   Java
    
    ```java
    HttpResponse<String> response = Unirest.put("https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91")
      .header("Content-Type", "application/json")
      .header("Authorization", "YOUR_OAUTH_TOKEN")
      .body({"datasource":{"dimensions_attributes":[{"entry_value":"another_slug","name":"Another Name"}],"name":"Labels for Website","slug":"label"}})
      .asString();
    ```
    
-   C#
    
    ```csharp
    var client = new RestClient("https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91");
    var request = new RestRequest(Method.PUT);
    
    request.AddHeader("Content-Type", "application/json");
    request.AddHeader("Authorization", "YOUR_OAUTH_TOKEN");
    request.AddParameter("application/json", "{\"datasource\":{\"dimensions_attributes\":[{\"entry_value\":\"another_slug\",\"name\":\"Another Name\"}],\"name\":\"Labels for Website\",\"slug\":\"label\"}}", ParameterType.RequestBody);
    IRestResponse response = client.Execute(request);
    ```
    
-   Python
    
    ```python
    import requests
    
    url = "https://mapi.storyblok.com/v1/spaces/288868932106293/datasources/91"
    
    querystring = {}
    
    payload = {"datasource":{"dimensions_attributes":[{"entry_value":"another_slug","name":"Another Name"}],"name":"Labels for Website","slug":"label"}}
    headers = {
      'Content-Type': "application/json",
      'Authorization': "YOUR_OAUTH_TOKEN"
    }
    
    response = requests.request("PUT", url, data=payload, headers=headers, params=querystring)
    
    print(response.text)
    ```
    
-   Ruby
    
    ```ruby
    require 'storyblok'
    client = Storyblok::Client.new(oauth_token: 'YOUR_OAUTH_TOKEN')
    
    payload = {"datasource" => {"dimensions_attributes" => [{"entry_value" => "another_slug","name" => "Another Name"}],"name" => "Labels for Website","slug" => "label"}}
    
    client.put('spaces/288868932106293/datasources/91', payload)
    ```
    
-   Swift
    
    ```swift
    let storyblok = URLSession(storyblok: .mapi(accessToken: .oauth("YOUR_OAUTH_TOKEN")))
    var request = URLRequest(storyblok: storyblok, path: "spaces/288868932106293/datasources/91")
    request.httpMethod = "PUT"
    request.httpBody = try JSONSerialization.data(withJSONObject: [
        "datasource": [
            "dimensions_attributes": [
                [
                    "entry_value": "another_slug",
                    "name": "Another Name",
                ],
            ],
            "name": "Labels for Website",
            "slug": "label",
        ],
    ])
    let (data, _) = try await storyblok.data(for: request)
    print(try JSONSerialization.jsonObject(with: data))
    ```
    
-   Kotlin
    
    ```kotlin
    val client = HttpClient {
        install(Storyblok(MAPI)) {
            accessToken = OAuth("YOUR_OAUTH_TOKEN")
        }
    }
    
    val response = client.put("spaces/288868932106293/datasources/91") {
        setBody(buildJsonObject {
            putJsonObject("datasource") {
                putJsonArray("dimensions_attributes") {
                    addJsonObject {
                        put("entry_value", "another_slug")
                        put("name", "Another Name")
                    }
                }
                put("name", "Labels for Website")
                put("slug", "label")
            }
        })
    }
    
    println(response.body<JsonElement>())
    ```

## Pagination

-   [Previous: The Datasource Object](/docs/api/management/datasources/the-datasource-object)
-   [Next: Discussions](/docs/api/management/discussions)
